Bug 830388 - Review Request: mingw-libarchive - MinGW package for libarchive
Summary: Review Request: mingw-libarchive - MinGW package for libarchive
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Nobody's working on this, feel free to take it
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 830387
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-06-09 06:08 UTC by Michael Cronenworth
Modified: 2012-12-04 05:00 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-11-29 06:47:10 UTC
greg.hellings: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Michael Cronenworth 2012-06-09 06:08:32 UTC
Spec URL: http://michael.cronenworth.com/RPMS/mingw-libarchive.spec
SRPM URL: http://michael.cronenworth.com/RPMS/mingw-libarchive-3.0.4-1.fc17.src.rpm
Description: Cross-compiled library for handling streaming archive formats
Fedora Account System Username: mooninite

Comment 1 Michael Cronenworth 2012-09-04 16:36:19 UTC
Testing note: Libarchive uses "secure" CRT calls (_s suffix) that were implemented in MinGW-w64 in August 2012. The CRT in Fedora is a snapshot from July 2012. Libarchive also calls _mkgmtime64 that does not seem to be supported in MinGW/Windows XP. You can only run the resulting library in Windows 7 or higher. I made a patch againsg libarchive so that libarchive could be run on XP, but I will need to test it before I consider applying it here.

Comment 2 Erik van Pienbroek 2012-10-08 19:47:29 UTC
Hey Michael,

The _mkgmtime64 on WinXP issue should be resolved with the mingw-headers/mingw-crt which is currently in F18-updates-testing

Comment 3 greg.hellings 2012-11-20 03:06:44 UTC
Now that I'm allowed to do these officially. Items marked + are good, and those marked - have issues.

+rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.

mingw32-bsdcpio.noarch: W: summary-not-capitalized C bsdcpio utility
mingw32-bsdcpio.noarch: W: spelling-error %description -l en_US libarchive -> lib archive, lib-archive, archive
mingw32-bsdcpio.noarch: W: no-documentation
mingw32-bsdtar.noarch: W: summary-not-capitalized C bsdtar utility
mingw32-bsdtar.noarch: W: spelling-error %description -l en_US libarchive -> lib archive, lib-archive, archive
mingw32-bsdtar.noarch: W: no-documentation
mingw32-libarchive.noarch: W: spelling-error %description -l en_US cpio -> CPI
mingw32-libarchive.noarch: W: spelling-error %description -l en_US ar -> AR, Ar, at
mingw32-libarchive.noarch: W: spelling-error %description -l en_US shar -> share, shear, shard
mingw32-libarchive-debuginfo.noarch: E: debuginfo-without-sources
mingw32-libarchive-static.noarch: W: no-documentation
mingw64-bsdcpio.noarch: W: summary-not-capitalized C bsdcpio utility
mingw64-bsdcpio.noarch: W: spelling-error %description -l en_US libarchive -> lib archive, lib-archive, archive
mingw64-bsdcpio.noarch: W: no-documentation
mingw64-bsdtar.noarch: W: summary-not-capitalized C bsdtar utility
mingw64-bsdtar.noarch: W: spelling-error %description -l en_US libarchive -> lib archive, lib-archive, archive
mingw64-bsdtar.noarch: W: no-documentation
mingw64-libarchive.noarch: W: spelling-error %description -l en_US cpio -> CPI
mingw64-libarchive.noarch: W: spelling-error %description -l en_US ar -> AR, Ar, at
mingw64-libarchive.noarch: W: spelling-error %description -l en_US shar -> share, shear, shard
mingw64-libarchive-debuginfo.noarch: E: debuginfo-without-sources
mingw64-libarchive-static.noarch: W: no-documentation
mingw-libarchive.src: W: spelling-error %description -l en_US cpio -> CPI
mingw-libarchive.src: W: spelling-error %description -l en_US ar -> AR, Ar, at
mingw-libarchive.src: W: spelling-error %description -l en_US shar -> share, shear, shard
mingw-libarchive.src: W: invalid-url Source0: http://libarchive.googlecode.com/files/libarchive-3.0.4.tar.gz HTTP Error 404: Not Found

It's been suggested to me that summaries for mingw packages begin with the string "MinGW build of...". That will conform better with other MinGW packages and eliminate lots of those warnings. I don't know if the %doc line is necessary for every package or not - but having it there would quiet those warnings as well.


+The package must be named according to the Package Naming Guidelines .
+The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. 
+The package must meet the Packaging Guidelines .
+The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
+The License field in the package spec file must match the actual license.
-If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

!! This is included in each of the base library builds, but not in the binary builds. I'm not sure if that's an issue or not.

+The spec file must be written in American English.
+The spec file for the package MUST be legible.
-The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

!! The URL has changed to distribute off of github.com. The address should now reflect https://github.com/downloads/libarchive/libarchive/libarchive-3.0.4.tar.gz
The hashes map between the one you provided and the upstream I linked.

+The package MUST successfully compile and build into binary rpms on at least one primary architecture. (I tested x86_64 on f17)
+If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
+All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
+The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
(n/a)Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
+Packages must NOT bundle copies of system libraries.
(n/a) If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
+A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
+A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
+Permissions on files must be set properly. Executables should be set with executable permissions, for example.
+Each package must consistently use macros.
+The package must contain code, or permissable content.
+Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
+If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
+Static libraries must be in a -static package.
(n/a) Development files must be in a -devel package.
(n/a) In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
+Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
+Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
+Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
+All filenames in rpm packages must be valid UTF-8.

So it looks like just a few things:
1) Add "MinGW build.." to the summaries
2) Determine whether the secondary packages need a %doc line
3) Fix the upstream source URL.

Lines that begin with 'Group:' are superflous, as Fedora makes no use of them. They can be deleted from your spec file.

There are also a few other files that might be potential %doc files that you're not including. For instance, you expressly convert NEWS from Latin1 to UTF-8, but then you don't include it in the %doc line. Why is that? README is also a potential for inclusion, I would suppose.

This is my first official review as a packager, so bear with me. Kalev is my mentor, so we can inquire of him regarding anything uncertain.

Comment 4 Michael Cronenworth 2012-11-20 05:05:51 UTC
(In reply to comment #3)
> So it looks like just a few things:
> 1) Add "MinGW build.." to the summaries

Fixed.

> 2) Determine whether the secondary packages need a %doc line

http://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Subpackage_Licensing

> 3) Fix the upstream source URL.

Fixed.

> Lines that begin with 'Group:' are superflous, as Fedora makes no use of
> them. They can be deleted from your spec file.

Removed.

> There are also a few other files that might be potential %doc files that
> you're not including. For instance, you expressly convert NEWS from Latin1
> to UTF-8, but then you don't include it in the %doc line. Why is that?
> README is also a potential for inclusion, I would suppose.

Copy-pasta from the native spec. I've removed NEWS, but added README. We don't include most documentation that can be found in the native package.

> This is my first official review as a packager, so bear with me. Kalev is my
> mentor, so we can inquire of him regarding anything uncertain.

Thanks.

http://michael.cronenworth.com/RPMS/mingw-libarchive.spec
http://michael.cronenworth.com/RPMS/mingw-libarchive-3.0.4-2.fc17.src.rpm

Comment 5 greg.hellings 2012-11-20 14:53:14 UTC
(In reply to comment #4)
> > 2) Determine whether the secondary packages need a %doc line
> 
> http://fedoraproject.org/wiki/Packaging:
> LicensingGuidelines#Subpackage_Licensing

Ah, there it is. Thanks!

The sub-package summaries still don't mention MinGW, but everything else looks fine. The new rpmlint run looks clean, and ready to ship.

mingw32-bsdcpio.noarch: W: summary-not-capitalized C bsdcpio utility
mingw32-bsdcpio.noarch: W: spelling-error %description -l en_US libarchive -> lib archive, lib-archive, archive
mingw32-bsdcpio.noarch: W: no-documentation
mingw32-bsdtar.noarch: W: summary-not-capitalized C bsdtar utility
mingw32-bsdtar.noarch: W: spelling-error %description -l en_US libarchive -> lib archive, lib-archive, archive
mingw32-bsdtar.noarch: W: no-documentation
mingw32-libarchive.noarch: W: spelling-error %description -l en_US cpio -> CPI
mingw32-libarchive.noarch: W: spelling-error %description -l en_US ar -> AR, Ar, at
mingw32-libarchive.noarch: W: spelling-error %description -l en_US shar -> share, shear, shard
mingw32-libarchive-debuginfo.noarch: E: debuginfo-without-sources
mingw32-libarchive-static.noarch: W: no-documentation
mingw64-bsdcpio.noarch: W: summary-not-capitalized C bsdcpio utility
mingw64-bsdcpio.noarch: W: spelling-error %description -l en_US libarchive -> lib archive, lib-archive, archive
mingw64-bsdcpio.noarch: W: no-documentation
mingw64-bsdtar.noarch: W: summary-not-capitalized C bsdtar utility
mingw64-bsdtar.noarch: W: spelling-error %description -l en_US libarchive -> lib archive, lib-archive, archive
mingw64-bsdtar.noarch: W: no-documentation
mingw64-libarchive.noarch: W: spelling-error %description -l en_US cpio -> CPI
mingw64-libarchive.noarch: W: spelling-error %description -l en_US ar -> AR, Ar, at
mingw64-libarchive.noarch: W: spelling-error %description -l en_US shar -> share, shear, shard
mingw64-libarchive-debuginfo.noarch: E: debuginfo-without-sources
mingw64-libarchive-static.noarch: W: no-documentation
mingw-libarchive.src: W: spelling-error %description -l en_US cpio -> CPI
mingw-libarchive.src: W: spelling-error %description -l en_US ar -> AR, Ar, at
mingw-libarchive.src: W: spelling-error %description -l en_US shar -> share, shear, shard

Comment 6 Michael Cronenworth 2012-11-21 03:16:56 UTC
(In reply to comment #5)
> The sub-package summaries still don't mention MinGW

These issues aren't blockers. You're free to set +review and mention they can be fixed in the initial commit. Thanks.

http://michael.cronenworth.com/RPMS/mingw-libarchive.spec
http://michael.cronenworth.com/RPMS/mingw-libarchive-3.0.4-3.fc17.src.rpm

Comment 7 greg.hellings 2012-11-23 04:00:02 UTC
Approved. Settings fedora-review flag.

Comment 8 Michael Cronenworth 2012-11-24 00:19:31 UTC
New Package SCM Request
=======================
Package Name: mingw-libarchive
Short Description: MinGW package for libarchive
Owners: mooninite
Branches: f17 f18
InitialCC:

Comment 9 Gwyn Ciesla 2012-11-24 18:15:27 UTC
Git done (by process-git-requests).

Comment 10 Fedora Update System 2012-11-24 20:55:15 UTC
mingw-libarchive-3.0.4-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/mingw-libarchive-3.0.4-3.fc18

Comment 11 Fedora Update System 2012-11-25 05:23:28 UTC
mingw-libarchive-3.0.4-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/mingw-libarchive-3.0.4-3.fc17

Comment 12 Fedora Update System 2012-11-25 19:29:35 UTC
mingw-libarchive-3.0.4-3.fc18 has been pushed to the Fedora 18 testing repository.

Comment 13 Fedora Update System 2012-11-29 06:47:12 UTC
mingw-libarchive-3.0.4-3.fc18 has been pushed to the Fedora 18 stable repository.

Comment 14 Fedora Update System 2012-12-04 05:00:42 UTC
mingw-libarchive-3.0.4-3.fc17 has been pushed to the Fedora 17 stable repository.


Note You need to log in before you can comment on or make changes to this bug.